#pragma once

#include <d3d11.h>
#include <d3dx10math.h>
#include "common.h"

class PlaneModelClass
	{
	private:
		struct VertexType
			{
			D3DXVECTOR3 position;
			D3DXVECTOR3 normal; //
			D3DXVECTOR4 Kd;  //ϵ
			D3DXVECTOR4 Ks;  //ʵĸ߹ϵ
			};
	public:
		PlaneModelClass(void);
		PlaneModelClass(const PlaneModelClass&);
		~PlaneModelClass(void);
		bool Initialize(ID3D11Device*,int,int,float);
		void Shutdown();
		void Render(ID3D11DeviceContext*);

		int GetIndexCount();
	private:
		bool InitializeBuffers(ID3D11Device*,int,int,float);
		void ShutdownBuffers();
		void RenderBuffers(ID3D11DeviceContext*);
		//㻺Ͷ
		ID3D11Buffer *m_vertexBuffer, *m_indexBuffer;
		int m_vertexCount, m_indexCount;
	};

