#pragma once

#include <d3d11.h>
#include <d3dx10math.h>

#if defined(DEBUG) || defined(_DEBUG)
#ifndef D3D_DEBUG_INFO
#define D3D_DEBUG_INFO
#endif
#endif

#if defined(DEBUG) || defined(_DEBUG)
#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>
#endif

#include <dxerr.h>
#include <cassert>

//һ򵥵Ĵ

#if defined(DEBUG) | defined(_DEBUG)
	#ifndef HR
	#define HR(x)                                              \
	{                                                          \
		HRESULT hr = (x);                                      \
		if(FAILED(hr))                                         \
		{                                                      \
			DXTrace(__FILE__, (DWORD)__LINE__, hr, L#x, true); \
		}                                                      \
	}
	#endif

#else
	#ifndef HR
	#define HR(x) (x)
	#endif
#endif 

//һЩɫ
const D3DXVECTOR4 WHITE(1.0f, 1.0f, 1.0f, 1.0f);
const D3DXVECTOR4 BLACK(0.0f, 0.0f, 0.0f, 1.0f);
const D3DXVECTOR4 RED(1.0f, 0.0f, 0.0f, 1.0f);
const D3DXVECTOR4 GREEN(0.0f, 1.0f, 0.0f, 1.0f);
const D3DXVECTOR4 BLUE(0.0f, 0.0f, 1.0f, 1.0f);
const D3DXVECTOR4 YELLOW(1.0f, 1.0f, 0.0f, 1.0f);
const D3DXVECTOR4 CYAN(0.0f, 1.0f, 1.0f, 1.0f); //ɫ
const D3DXVECTOR4 MAGENTA(1.0f, 0.0f, 1.0f, 1.0f);//ɫ

const D3DXVECTOR4 BEACH_SAND(1.0f, 0.96f, 0.62f, 1.0f);
const D3DXVECTOR4 LIGHT_YELLOW_GREEN(0.48f, 0.77f, 0.46f, 1.0f);
const D3DXVECTOR4 DARK_YELLOW_GREEN(0.1f, 0.48f, 0.19f, 1.0f);
const D3DXVECTOR4 DARKBROWN(0.45f, 0.39f, 0.34f, 1.0f);

#define NUM_LIGHTS 2

struct  LightBufferType
	{
	D3DXVECTOR4 lightPosition[NUM_LIGHTS]; //Դλ
	D3DXVECTOR4 lightColor[NUM_LIGHTS];   //Դɫ
	D3DXVECTOR4 globalAmbient[NUM_LIGHTS]; //ԴĻⷴϵ
	D3DXVECTOR4 attenuation[NUM_LIGHTS]; //˥ϵx,y,zӦԺͶϵ
	D3DXVECTOR4 spotlight[NUM_LIGHTS];//spotlightxyֱ洢ںcosֵ
	D3DXVECTOR3 lightDirection[NUM_LIGHTS]; //ƽйⷽ
	float shininess[NUM_LIGHTS]; //߹ָ

	};

struct  MaterialBufferType
	{
	D3DXVECTOR4 Ke;  //ʵԷ
	D3DXVECTOR4 Ka;  //ʵĻϵ
	};

struct CameraBufferType
	{
		D3DXVECTOR4 cameraPosition; //λ
	};