#pragma once
#include <d3d11.h>
#include <d3dx10math.h>
#include <d3dx11async.h>
#include <fstream>
#include "common.h"
#include "LightClass.h"

using namespace std;

class LightShaderClass
	{
	private:
	//shaderconst bufferṹһ£ҪЩshaderֵ
	struct MatrixBufferType
		{
		D3DXMATRIX world;
		D3DXMATRIX view;
		D3DXMATRIX projection;
		};

	public:
		LightShaderClass(void);
		LightShaderClass(const LightShaderClass &);
		~LightShaderClass(void);
		bool Initialize(ID3D11Device*, HWND);
		void Shutdown();
		bool Render(ID3D11DeviceContext* , int , D3DXMATRIX , D3DXMATRIX , D3DXMATRIX ,  LightBufferType, MaterialBufferType, CameraBufferType);
		bool InitializeShader(ID3D11Device*, HWND, WCHAR*, WCHAR*);
		void ShutdownShader();
		void OutputShaderErrorMessage(ID3D10Blob*, HWND, WCHAR*);

		bool SetShaderParameters(ID3D11DeviceContext* , D3DXMATRIX , D3DXMATRIX , D3DXMATRIX, LightBufferType, MaterialBufferType, CameraBufferType);
		void RenderShader(ID3D11DeviceContext*, int);

	private:
		ID3D11VertexShader* m_vertexShader;
		ID3D11PixelShader* m_pixelShader;
		ID3D11InputLayout* m_layout;
		ID3D11Buffer* m_matrixBuffer;
		ID3D11Buffer* m_lightBuffer; //ʹղbuffer
		ID3D11Buffer* m_materialBuffer;
		ID3D11Buffer* m_cameraBuffer; //buffer
	};

