#include "SystemClass.h"


SystemClass::SystemClass(void)
	{
	m_Input = 0;
	m_Graphics = 0;

	m_Timer = 0;

	}

SystemClass::SystemClass(const SystemClass &)
	{

	}

SystemClass::~SystemClass(void)
	{
	}

//ôڳʼһЩĳʼ
bool SystemClass::Initialize()
	{
	bool result;
	int screenWidth = 0, screenHeight = 0;

	// ʼ
	InitializeWindows(screenWidth, screenHeight);

	//input
	m_Input = new InputClass;
	if(!m_Input)
		{
		return false;
		}

	// ʼ.
	m_Input->Initialize();

	// ͼζȾӦóе
	m_Graphics = new GraphicsClass;
	if(!m_Graphics)
		{
		return false;
		}
	// ʼͼζ
	result = m_Graphics->Initialize(screenWidth, screenHeight, m_hwnd);
	if(!result)
		{
		return false;
		}
	// ʱ.
	m_Timer = new TimerClass;
	if(!m_Timer)
		{
		return false;
		}

	// ʼʱ
	result = m_Timer->Initialize();
	if(!result)
		{
		MessageBox(m_hwnd, L"Could not initialize the Timer object.", L"Error", MB_OK);
		return false;
		}



	return true;
	}

void SystemClass::Shutdown()
	{
	//һЩٹ
	// ͷżʱ.
	if(m_Timer)
		{
		delete m_Timer;
		m_Timer = 0;
		}


	if(m_Graphics)
		{
		m_Graphics->Shutdown();
		delete m_Graphics;
		m_Graphics = 0;
		}

	if(m_Input)
		{
		delete m_Input;
		m_Input = 0;
		}
	// ִһЩٹ.
	ShutdownWindows();

	}

//Ϣ
void  SystemClass::Run()
	{
	MSG msg;
	bool done, result ;


	// ʼϢṹ.
	ZeroMemory(&msg, sizeof(MSG));

	// ѭϢյWM_QUIT.
	done = false;
	while(!done)
		{
		// windowsϢ.
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
			}

		// յWM_QUITϢ˳.
		if(msg.message == WM_QUIT)
			{
			done = true;
			}
		else
			{

			//ǵȾԷ
			//....
			//.....
			result = Frame();
			if(!result)
				{
				done = true;
				}
			}

		}

	return;
	}

bool SystemClass::Frame()
	{
	bool result;

	//ûǷESC£˳.
	if(m_Input->IsKeyDown(VK_ESCAPE))
		{
		return false;
		}

	//A,S,D,W,Q,E,Z,X,C£ƶ
	if(GetAsyncKeyState('W') & 0x8000)	//ǰ
		m_Graphics->m_Camera->walk(-0.1);
	if(GetAsyncKeyState('S') & 0x8000)	
		m_Graphics->m_Camera->walk(0.1);
	if(GetAsyncKeyState('A') & 0x8000)	//
		m_Graphics->m_Camera->strafe(-0.1);
	if(GetAsyncKeyState('D') & 0x8000)	
		m_Graphics->m_Camera->strafe(0.1);
	if(GetAsyncKeyState('Q') & 0x8000)	//
		m_Graphics->m_Camera->fly(-0.1);
	if(GetAsyncKeyState('E') & 0x8000)	
		m_Graphics->m_Camera->fly(0.1);
	if(GetAsyncKeyState('Z') & 0x8000)	
		m_Graphics->m_Camera->pitch(PI/180);
	if(GetAsyncKeyState('X') & 0x8000)	
		m_Graphics->m_Camera->yaw(PI/180);
	if(GetAsyncKeyState('C') & 0x8000)	
		m_Graphics->m_Camera->roll(PI/180);
	if(GetAsyncKeyState('R') & 0x8000)//λ	
		{
		// λ.
		m_Graphics->m_Camera->Reset();
		D3DXVECTOR3 campos = D3DXVECTOR3(0.0f, 0.0f, -10.0f);
		m_Graphics->m_Camera->setPosition(&campos);
		}


	m_Timer->Frame();

	//ת
	//m_Graphics->m_Camera->roll(m_Timer->GetTime()/1000);

	// ִ֡Ⱦ.
	result = m_Graphics->Frame(m_Timer->GetTime()/1000);
	if(!result)
		{
		return false;
		}
	return true;
	}

//ʼ࣬Ӧó򴰿
void SystemClass::InitializeWindows(int& screenWidth, int& screenHeight)
	{
	WNDCLASSEX wc;
	DEVMODE dmScreenSettings;
	int posX, posY;

	//õӦóָ
	ApplicationHandle = this;

	// õӦóʵ
	m_hinstance = GetModuleHandle(NULL);

	// Ӧó
	m_applicationName = L"Engine";

	// ô.
	wc.style         = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wc.lpfnWndProc   = WndProc; //ָص
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = m_hinstance;
	wc.hIcon		 = LoadIcon(NULL, IDI_WINLOGO);
	wc.hIconSm       = wc.hIcon;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH); //ĬϺɫںɫ
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = m_applicationName;
	wc.cbSize        = sizeof(WNDCLASSEX);

	// עᴰ
	RegisterClassEx(&wc);

	// õwindowsֱ
	screenWidth  = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);

	// Ƿȫòͬķֱ.
	if(FULL_SCREEN)
		{
		//ȫģʽ£ôڴСΪwindowsֱ.
		memset(&dmScreenSettings, 0, sizeof(dmScreenSettings));
		dmScreenSettings.dmSize       = sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth  = (unsigned long)screenWidth;
		dmScreenSettings.dmPelsHeight = (unsigned long)screenHeight;
		dmScreenSettings.dmBitsPerPel = 32;			
		dmScreenSettings.dmFields     = DM_BITSPERPEL | DM_PELSWIDTH | DM_PELSHEIGHT;

		// ʱʾ豸Ϊȫģʽע⣺Ӧó˳ʱ򣬽ָϵͳĬá
		ChangeDisplaySettings(&dmScreenSettings, CDS_FULLSCREEN);

		// ôڵĬλΪ(0,0).
		posX = posY = 0;
		}
	else
		{
		// ģʽ800*600.
		screenWidth  = 800;
		screenHeight = 600;

		// λ,posX, posYϽ
		posX = (GetSystemMetrics(SM_CXSCREEN) - screenWidth)  / 2;
		posY = (GetSystemMetrics(SM_CYSCREEN) - screenHeight) / 2;
		}

	// ȫʹʹòͬĲ.
	if( FULL_SCREEN)
		{
		m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName, 
			WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_POPUP,
			posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);
		}
	else
		{
		m_hwnd = CreateWindowEx(WS_EX_APPWINDOW, m_applicationName, m_applicationName, 
			WS_OVERLAPPEDWINDOW,
			posX, posY, screenWidth, screenHeight, NULL, NULL, m_hinstance, NULL);
		}

	// ʾڲΪ.
	ShowWindow(m_hwnd, SW_SHOW);
	SetForegroundWindow(m_hwnd);
	SetFocus(m_hwnd);

	// .
	//ShowCursor(false);


	}

void SystemClass::ShutdownWindows()
	{
	//ʾ.
	//ShowCursor(true);

	// ָĬʾ.
	if(FULL_SCREEN)
		{
		ChangeDisplaySettings(NULL, 0);
		}

	// ٴ
	DestroyWindow(m_hwnd);
	m_hwnd = NULL;

	// Ӧóʵ.
	UnregisterClass(m_applicationName, m_hinstance);
	m_hinstance = NULL;
	ApplicationHandle = NULL;

	return;

	}

LRESULT CALLBACK SystemClass::MessageHandler(HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam)
	{

	switch(umsg)
		{
		// ⰴϢ.
	case WM_KEYDOWN:
		{
		m_Input->KeyDown((unsigned int)wparam);
		return 0;
		}

	case WM_KEYUP:
		{
		m_Input->KeyUp((unsigned int)wparam);
		return 0;
		}
		//κϢ͵windowsȱʡ.
	case WM_SIZE:
		{
		int screenWidth = 0, screenHeight = 0;
		screenWidth  = LOWORD(lparam);
		screenHeight = HIWORD(lparam);
		// ڴСıʱ³ʼͼζ
		if(m_Graphics)
			{
			bool result = m_Graphics->Initialize(screenWidth, screenHeight, m_hwnd);
			if(!result)
				{
				return false;
				}
			}

		return 0;
		}
	default:
		{
		return DefWindowProc(hwnd, umsg, wparam, lparam);
		}
		}
	}

LRESULT CALLBACK WndProc(HWND hwnd, UINT umessage, WPARAM wparam, LPARAM lparam)
	{
	switch(umessage)
		{

		// Ϣ.
	case WM_DESTROY:
		{
		PostQuitMessage(0);
		return 0;
		}

		// ڹرϢ.
	case WM_CLOSE:
		{
		PostQuitMessage(0);		
		return 0;
		}

		//MessageHandle̴Ϣ.
	default:
		{
		return ApplicationHandle->MessageHandler(hwnd, umessage, wparam, lparam);
		}
		}
	}