#pragma once

#include <d3d11.h>
#include <d3dx10math.h>
#include <vector>
#include "common.h"

using namespace std;

class WaterModelClass
	{
	private:
		struct VertexType
			{
			D3DXVECTOR3 position;
			D3DXVECTOR3 normal;
			D3DXVECTOR2 texture;//
			D3DXCOLOR Kd; //ʵϵ
			D3DXCOLOR Ks; //ʵĸ߹ϵ
			};
	public:
		WaterModelClass(void);
		WaterModelClass(const WaterModelClass&);
		~WaterModelClass(void);

		bool Initialize(ID3D11Device*, int, int, float, float, float, float);
		void Shutdown();
		void Render(ID3D11DeviceContext*);

		int GetIndexCount();
		bool update(ID3D11DeviceContext*, float );
		void disturb(int ,int , float);

	private:
		bool InitializeBuffers(ID3D11Device*, int, int, float, float, float, float);
		void ShutdownBuffers();
		void RenderBuffers(ID3D11DeviceContext*);
		//㻺Ͷ
		ID3D11Buffer *m_vertexBuffer, *m_indexBuffer;
		int m_vertexCount, m_indexCount;

		//ά
		int m_NumRows, m_NumCols;

		// ģⳣ.
		float mK1;
		float mK2;
		float mK3;

		float mTimeStep;
		float mSpatialStep;

		D3DXVECTOR3* mPrevSolution;
		D3DXVECTOR3* mCurrSolution;
		D3DXVECTOR3* mNormals; //

		//ʱ
		VertexType* vertices;
	};

